#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_cJIK2x0x32TN2x1x2_a1_b0
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=2, NB=0, KB=32, 
 * lda=32, ldb=32, ldc=0, mu=2, nu=1, ku=2, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   #define Nb N
   const float *stM = A + 64;
   const float *stN = B + (((Nb) << 5));
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*2*1)/(2*N*sizeof(float));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 2
   const int incAm = 32, incAn = -64;
   #define incBk 2
   const int incBm = -32, incBn = 32;
   #define incCm 4
   const int incCn = (((ldc) << 1)) - 4;
   float *pC0=C;
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0, rA1;
   register float rB0;
   register float rC0_0, rC1_0;
   do /* N-loop */
   {
      ATL_pfl1R(pfA);
      pfA += incPFA;
/*
 *    Feeble prefetch of C
 */
      rC0_0 = *pC0;
      ATL_pfl1W(pC0);
/*
 *    Peel 1st iter to assign C regs
 */
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = pA0[32];
      rC0_0 = rA0 * rB0;
      rC1_0 = rA1 * rB0;
      rA0 = pA0[1];
      rB0 = pB0[1];
      rA1 = pA0[33];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      pA0 += incAk;
      pB0 += incBk;
/*
 *    Unpeeled K iterations
 */
      for (k=30; k; k -= 2) /* easy loop to unroll */
      {
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[32];
         rC0_0 += rA0 * rB0;
         rC1_0 += rA1 * rB0;
         rA0 = pA0[1];
         rB0 = pB0[1];
         rA1 = pA0[33];
         rC0_0 += rA0 * rB0;
         rC1_0 += rA1 * rB0;
         pA0 += incAk;
         pB0 += incBk;
      }
      *pC0 = rC0_0;
      pC0[2] = rC1_0;
      pC0 += incCm;
      pA0 += incAm;
      pB0 += incBm;
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
static void ATL_cJIK32x0x32TN6x1x2_a1_b0
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=32, NB=0, KB=32, 
 * lda=32, ldb=32, ldc=0, mu=6, nu=1, ku=2, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   #define Nb N
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + 960;
   const float *stN = B + (((Nb) << 5));
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*6*1)/(32*N*sizeof(float));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 2
   const int incAm = 160, incAn = -960;
   #define incBk 2
   const int incBm = -32, incBn = 32;
   #define incCm 12
   const int incCn = (((ldc) << 1)) - 60;
   float *pC0=C;
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0, rA1, rA2, rA3, rA4, rA5;
   register float rB0;
   register float rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC5_0;
   do /* N-loop */
   {
      do /* M-loop */
      {
         ATL_pfl1R(pfA);
         pfA += incPFA;
/*
 *       Feeble prefetch of C
 */
         rC0_0 = *pC0;
         ATL_pfl1W(pC0);
/*
 *       Peel 1st iter to assign C regs
 */
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[32];
         rA2 = pA0[64];
         rA3 = pA0[96];
         rC0_0 = rA0 * rB0;
         rA4 = pA0[128];
         rC1_0 = rA1 * rB0;
         rA5 = pA0[160];
         rC2_0 = rA2 * rB0;
         rC3_0 = rA3 * rB0;
         rC4_0 = rA4 * rB0;
         rC5_0 = rA5 * rB0;
         rA0 = pA0[1];
         rB0 = pB0[1];
         rA1 = pA0[33];
         rA2 = pA0[65];
         rA3 = pA0[97];
         rC0_0 += rA0 * rB0;
         rA4 = pA0[129];
         rC1_0 += rA1 * rB0;
         rA5 = pA0[161];
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         pA0 += incAk;
         pB0 += incBk;
/*
 *       Unpeeled K iterations
 */
         for (k=30; k; k -= 2) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rA1 = pA0[32];
            rA2 = pA0[64];
            rA3 = pA0[96];
            rC0_0 += rA0 * rB0;
            rA4 = pA0[128];
            rC1_0 += rA1 * rB0;
            rA5 = pA0[160];
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rA1 = pA0[33];
            rA2 = pA0[65];
            rA3 = pA0[97];
            rC0_0 += rA0 * rB0;
            rA4 = pA0[129];
            rC1_0 += rA1 * rB0;
            rA5 = pA0[161];
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            pA0 += incAk;
            pB0 += incBk;
         }
         *pC0 = rC0_0;
         pC0[2] = rC1_0;
         pC0[4] = rC2_0;
         pC0[6] = rC3_0;
         pC0[8] = rC4_0;
         pC0[10] = rC5_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
   ATL_cJIK2x0x32TN2x1x2_a1_b0(2, N, 32, alpha, ca + 960, lda, cb, ldb, beta, cc + 60, ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_cJIK2x0x32TN2x8x2_a1_b0
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=2, NB=0, KB=32, 
 * lda=32, ldb=32, ldc=0, mu=2, nu=8, ku=2, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const int Nb = (N>>3)<<3;
   const float *stM = A + 64;
   const float *stN = B + (((Nb) << 5));
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*2*8)/(2*N*sizeof(float));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 2
   const int incAm = 32, incAn = -64;
   #define incBk 2
   const int incBm = -32, incBn = 256;
   #define incCm 4
   const int incCn = (((ldc) << 4)) - 4;
   float *pC0=C, *pC1=pC0+(((ldc) << 1)), *pC2=pC1+(((ldc) << 1)), *pC3=pC2+(((ldc) << 1)), *pC4=pC3+(((ldc) << 1)), *pC5=pC4+(((ldc) << 1)), *pC6=pC5+(((ldc) << 1)), *pC7=pC6+(((ldc) << 1));
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0, rA1;
   register float rB0, rB1, rB2, rB3, rB4, rB5, rB6, rB7;
   register float rC0_0, rC1_0, rC0_1, rC1_1, rC0_2, rC1_2, rC0_3, rC1_3, rC0_4, rC1_4, rC0_5, rC1_5, rC0_6, rC1_6, rC0_7, rC1_7;
   do /* N-loop */
   {
      ATL_pfl1R(pfA);
      pfA += incPFA;
/*
 *    Feeble prefetch of C
 */
      rC0_0 = *pC0;
      rC0_1 = *pC1;
      rC0_2 = *pC2;
      rC0_3 = *pC3;
      rC0_4 = *pC4;
      rC0_5 = *pC5;
      rC0_6 = *pC6;
      rC0_7 = *pC7;
      ATL_pfl1W(pC0);
      ATL_pfl1W(pC1);
      ATL_pfl1W(pC2);
      ATL_pfl1W(pC3);
      ATL_pfl1W(pC4);
      ATL_pfl1W(pC5);
      ATL_pfl1W(pC6);
      ATL_pfl1W(pC7);
/*
 *    Peel 1st iter to assign C regs
 */
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = pA0[32];
      rB1 = pB0[32];
      rB2 = pB0[64];
      rC0_0 = rA0 * rB0;
      rB3 = pB0[96];
      rC1_0 = rA1 * rB0;
      rB4 = pB0[128];
      rC0_1 = rA0 * rB1;
      rB5 = pB0[160];
      rC1_1 = rA1 * rB1;
      rB6 = pB0[192];
      rC0_2 = rA0 * rB2;
      rB7 = pB0[224];
      rC1_2 = rA1 * rB2;
      rC0_3 = rA0 * rB3;
      rC1_3 = rA1 * rB3;
      rC0_4 = rA0 * rB4;
      rC1_4 = rA1 * rB4;
      rC0_5 = rA0 * rB5;
      rC1_5 = rA1 * rB5;
      rC0_6 = rA0 * rB6;
      rC1_6 = rA1 * rB6;
      rC0_7 = rA0 * rB7;
      rC1_7 = rA1 * rB7;
      rA0 = pA0[1];
      rB0 = pB0[1];
      rA1 = pA0[33];
      rB1 = pB0[33];
      rB2 = pB0[65];
      rC0_0 += rA0 * rB0;
      rB3 = pB0[97];
      rC1_0 += rA1 * rB0;
      rB4 = pB0[129];
      rC0_1 += rA0 * rB1;
      rB5 = pB0[161];
      rC1_1 += rA1 * rB1;
      rB6 = pB0[193];
      rC0_2 += rA0 * rB2;
      rB7 = pB0[225];
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC0_4 += rA0 * rB4;
      rC1_4 += rA1 * rB4;
      rC0_5 += rA0 * rB5;
      rC1_5 += rA1 * rB5;
      rC0_6 += rA0 * rB6;
      rC1_6 += rA1 * rB6;
      rC0_7 += rA0 * rB7;
      rC1_7 += rA1 * rB7;
      pA0 += incAk;
      pB0 += incBk;
/*
 *    Unpeeled K iterations
 */
      for (k=30; k; k -= 2) /* easy loop to unroll */
      {
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[32];
         rB1 = pB0[32];
         rB2 = pB0[64];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[96];
         rC1_0 += rA1 * rB0;
         rB4 = pB0[128];
         rC0_1 += rA0 * rB1;
         rB5 = pB0[160];
         rC1_1 += rA1 * rB1;
         rB6 = pB0[192];
         rC0_2 += rA0 * rB2;
         rB7 = pB0[224];
         rC1_2 += rA1 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC0_5 += rA0 * rB5;
         rC1_5 += rA1 * rB5;
         rC0_6 += rA0 * rB6;
         rC1_6 += rA1 * rB6;
         rC0_7 += rA0 * rB7;
         rC1_7 += rA1 * rB7;
         rA0 = pA0[1];
         rB0 = pB0[1];
         rA1 = pA0[33];
         rB1 = pB0[33];
         rB2 = pB0[65];
         rC0_0 += rA0 * rB0;
         rB3 = pB0[97];
         rC1_0 += rA1 * rB0;
         rB4 = pB0[129];
         rC0_1 += rA0 * rB1;
         rB5 = pB0[161];
         rC1_1 += rA1 * rB1;
         rB6 = pB0[193];
         rC0_2 += rA0 * rB2;
         rB7 = pB0[225];
         rC1_2 += rA1 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC0_5 += rA0 * rB5;
         rC1_5 += rA1 * rB5;
         rC0_6 += rA0 * rB6;
         rC1_6 += rA1 * rB6;
         rC0_7 += rA0 * rB7;
         rC1_7 += rA1 * rB7;
         pA0 += incAk;
         pB0 += incBk;
      }
      *pC0 = rC0_0;
      pC0[2] = rC1_0;
      *pC1 = rC0_1;
      pC1[2] = rC1_1;
      *pC2 = rC0_2;
      pC2[2] = rC1_2;
      *pC3 = rC0_3;
      pC3[2] = rC1_3;
      *pC4 = rC0_4;
      pC4[2] = rC1_4;
      *pC5 = rC0_5;
      pC5[2] = rC1_5;
      *pC6 = rC0_6;
      pC6[2] = rC1_6;
      *pC7 = rC0_7;
      pC7[2] = rC1_7;
      pC0 += incCm;
      pC1 += incCm;
      pC2 += incCm;
      pC3 += incCm;
      pC4 += incCm;
      pC5 += incCm;
      pC6 += incCm;
      pC7 += incCm;
      pA0 += incAm;
      pB0 += incBm;
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pC3 += incCn;
      pC4 += incCn;
      pC5 += incCn;
      pC6 += incCn;
      pC7 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_cJIK32x0x32TN32x32x0_a1_b0
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=32, NB=0, KB=32, 
 * lda=32, ldb=32, ldc=0, mu=6, nu=8, ku=2, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const int Nb = (N>>3)<<3;
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + 960;
   const float *stN = B + (((Nb) << 5));
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*6*8)/(32*N*sizeof(float));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 2
   const int incAm = 160, incAn = -960;
   #define incBk 2
   const int incBm = -32, incBn = 256;
   #define incCm 12
   const int incCn = (((ldc) << 4)) - 60;
   float *pC0=C, *pC1=pC0+(((ldc) << 1)), *pC2=pC1+(((ldc) << 1)), *pC3=pC2+(((ldc) << 1)), *pC4=pC3+(((ldc) << 1)), *pC5=pC4+(((ldc) << 1)), *pC6=pC5+(((ldc) << 1)), *pC7=pC6+(((ldc) << 1));
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0, rA1, rA2, rA3, rA4, rA5;
   register float rB0, rB1, rB2, rB3, rB4, rB5, rB6, rB7;
   register float rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC5_0, rC0_1, rC1_1, rC2_1, rC3_1, rC4_1, rC5_1, rC0_2, rC1_2, rC2_2, rC3_2, rC4_2, rC5_2, rC0_3, rC1_3, rC2_3, rC3_3, rC4_3, rC5_3, rC0_4, rC1_4, rC2_4, rC3_4, rC4_4, rC5_4, rC0_5, rC1_5, rC2_5, rC3_5, rC4_5, rC5_5, rC0_6, rC1_6, rC2_6, rC3_6, rC4_6, rC5_6, rC0_7, rC1_7, rC2_7, rC3_7, rC4_7, rC5_7;
   if (pB0 != stN)
   {
      do /* N-loop */
      {
         do /* M-loop */
         {
            ATL_pfl1R(pfA);
            pfA += incPFA;
/*
 *          Feeble prefetch of C
 */
            rC0_0 = *pC0;
            rC0_1 = *pC1;
            rC0_2 = *pC2;
            rC0_3 = *pC3;
            rC0_4 = *pC4;
            rC0_5 = *pC5;
            rC0_6 = *pC6;
            rC0_7 = *pC7;
            ATL_pfl1W(pC0);
            ATL_pfl1W(pC1);
            ATL_pfl1W(pC2);
            ATL_pfl1W(pC3);
            ATL_pfl1W(pC4);
            ATL_pfl1W(pC5);
            ATL_pfl1W(pC6);
            ATL_pfl1W(pC7);
/*
 *          Peel 1st iter to assign C regs
 */
            rA0 = *pA0;
            rB0 = *pB0;
            rA1 = pA0[32];
            rA2 = pA0[64];
            rA3 = pA0[96];
            rC0_0 = rA0 * rB0;
            rA4 = pA0[128];
            rC1_0 = rA1 * rB0;
            rA5 = pA0[160];
            rC2_0 = rA2 * rB0;
            rB1 = pB0[32];
            rC3_0 = rA3 * rB0;
            rB2 = pB0[64];
            rC4_0 = rA4 * rB0;
            rB3 = pB0[96];
            rC5_0 = rA5 * rB0;
            rB4 = pB0[128];
            rC0_1 = rA0 * rB1;
            rB5 = pB0[160];
            rC1_1 = rA1 * rB1;
            rB6 = pB0[192];
            rC2_1 = rA2 * rB1;
            rB7 = pB0[224];
            rC3_1 = rA3 * rB1;
            rC4_1 = rA4 * rB1;
            rC5_1 = rA5 * rB1;
            rC0_2 = rA0 * rB2;
            rC1_2 = rA1 * rB2;
            rC2_2 = rA2 * rB2;
            rC3_2 = rA3 * rB2;
            rC4_2 = rA4 * rB2;
            rC5_2 = rA5 * rB2;
            rC0_3 = rA0 * rB3;
            rC1_3 = rA1 * rB3;
            rC2_3 = rA2 * rB3;
            rC3_3 = rA3 * rB3;
            rC4_3 = rA4 * rB3;
            rC5_3 = rA5 * rB3;
            rC0_4 = rA0 * rB4;
            rC1_4 = rA1 * rB4;
            rC2_4 = rA2 * rB4;
            rC3_4 = rA3 * rB4;
            rC4_4 = rA4 * rB4;
            rC5_4 = rA5 * rB4;
            rC0_5 = rA0 * rB5;
            rC1_5 = rA1 * rB5;
            rC2_5 = rA2 * rB5;
            rC3_5 = rA3 * rB5;
            rC4_5 = rA4 * rB5;
            rC5_5 = rA5 * rB5;
            rC0_6 = rA0 * rB6;
            rC1_6 = rA1 * rB6;
            rC2_6 = rA2 * rB6;
            rC3_6 = rA3 * rB6;
            rC4_6 = rA4 * rB6;
            rC5_6 = rA5 * rB6;
            rC0_7 = rA0 * rB7;
            rC1_7 = rA1 * rB7;
            rC2_7 = rA2 * rB7;
            rC3_7 = rA3 * rB7;
            rC4_7 = rA4 * rB7;
            rC5_7 = rA5 * rB7;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rA1 = pA0[33];
            rA2 = pA0[65];
            rA3 = pA0[97];
            rC0_0 += rA0 * rB0;
            rA4 = pA0[129];
            rC1_0 += rA1 * rB0;
            rA5 = pA0[161];
            rC2_0 += rA2 * rB0;
            rB1 = pB0[33];
            rC3_0 += rA3 * rB0;
            rB2 = pB0[65];
            rC4_0 += rA4 * rB0;
            rB3 = pB0[97];
            rC5_0 += rA5 * rB0;
            rB4 = pB0[129];
            rC0_1 += rA0 * rB1;
            rB5 = pB0[161];
            rC1_1 += rA1 * rB1;
            rB6 = pB0[193];
            rC2_1 += rA2 * rB1;
            rB7 = pB0[225];
            rC3_1 += rA3 * rB1;
            rC4_1 += rA4 * rB1;
            rC5_1 += rA5 * rB1;
            rC0_2 += rA0 * rB2;
            rC1_2 += rA1 * rB2;
            rC2_2 += rA2 * rB2;
            rC3_2 += rA3 * rB2;
            rC4_2 += rA4 * rB2;
            rC5_2 += rA5 * rB2;
            rC0_3 += rA0 * rB3;
            rC1_3 += rA1 * rB3;
            rC2_3 += rA2 * rB3;
            rC3_3 += rA3 * rB3;
            rC4_3 += rA4 * rB3;
            rC5_3 += rA5 * rB3;
            rC0_4 += rA0 * rB4;
            rC1_4 += rA1 * rB4;
            rC2_4 += rA2 * rB4;
            rC3_4 += rA3 * rB4;
            rC4_4 += rA4 * rB4;
            rC5_4 += rA5 * rB4;
            rC0_5 += rA0 * rB5;
            rC1_5 += rA1 * rB5;
            rC2_5 += rA2 * rB5;
            rC3_5 += rA3 * rB5;
            rC4_5 += rA4 * rB5;
            rC5_5 += rA5 * rB5;
            rC0_6 += rA0 * rB6;
            rC1_6 += rA1 * rB6;
            rC2_6 += rA2 * rB6;
            rC3_6 += rA3 * rB6;
            rC4_6 += rA4 * rB6;
            rC5_6 += rA5 * rB6;
            rC0_7 += rA0 * rB7;
            rC1_7 += rA1 * rB7;
            rC2_7 += rA2 * rB7;
            rC3_7 += rA3 * rB7;
            rC4_7 += rA4 * rB7;
            rC5_7 += rA5 * rB7;
            pA0 += incAk;
            pB0 += incBk;
/*
 *          Unpeeled K iterations
 */
            for (k=30; k; k -= 2) /* easy loop to unroll */
            {
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = pA0[32];
               rA2 = pA0[64];
               rA3 = pA0[96];
               rC0_0 += rA0 * rB0;
               rA4 = pA0[128];
               rC1_0 += rA1 * rB0;
               rA5 = pA0[160];
               rC2_0 += rA2 * rB0;
               rB1 = pB0[32];
               rC3_0 += rA3 * rB0;
               rB2 = pB0[64];
               rC4_0 += rA4 * rB0;
               rB3 = pB0[96];
               rC5_0 += rA5 * rB0;
               rB4 = pB0[128];
               rC0_1 += rA0 * rB1;
               rB5 = pB0[160];
               rC1_1 += rA1 * rB1;
               rB6 = pB0[192];
               rC2_1 += rA2 * rB1;
               rB7 = pB0[224];
               rC3_1 += rA3 * rB1;
               rC4_1 += rA4 * rB1;
               rC5_1 += rA5 * rB1;
               rC0_2 += rA0 * rB2;
               rC1_2 += rA1 * rB2;
               rC2_2 += rA2 * rB2;
               rC3_2 += rA3 * rB2;
               rC4_2 += rA4 * rB2;
               rC5_2 += rA5 * rB2;
               rC0_3 += rA0 * rB3;
               rC1_3 += rA1 * rB3;
               rC2_3 += rA2 * rB3;
               rC3_3 += rA3 * rB3;
               rC4_3 += rA4 * rB3;
               rC5_3 += rA5 * rB3;
               rC0_4 += rA0 * rB4;
               rC1_4 += rA1 * rB4;
               rC2_4 += rA2 * rB4;
               rC3_4 += rA3 * rB4;
               rC4_4 += rA4 * rB4;
               rC5_4 += rA5 * rB4;
               rC0_5 += rA0 * rB5;
               rC1_5 += rA1 * rB5;
               rC2_5 += rA2 * rB5;
               rC3_5 += rA3 * rB5;
               rC4_5 += rA4 * rB5;
               rC5_5 += rA5 * rB5;
               rC0_6 += rA0 * rB6;
               rC1_6 += rA1 * rB6;
               rC2_6 += rA2 * rB6;
               rC3_6 += rA3 * rB6;
               rC4_6 += rA4 * rB6;
               rC5_6 += rA5 * rB6;
               rC0_7 += rA0 * rB7;
               rC1_7 += rA1 * rB7;
               rC2_7 += rA2 * rB7;
               rC3_7 += rA3 * rB7;
               rC4_7 += rA4 * rB7;
               rC5_7 += rA5 * rB7;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA0[33];
               rA2 = pA0[65];
               rA3 = pA0[97];
               rC0_0 += rA0 * rB0;
               rA4 = pA0[129];
               rC1_0 += rA1 * rB0;
               rA5 = pA0[161];
               rC2_0 += rA2 * rB0;
               rB1 = pB0[33];
               rC3_0 += rA3 * rB0;
               rB2 = pB0[65];
               rC4_0 += rA4 * rB0;
               rB3 = pB0[97];
               rC5_0 += rA5 * rB0;
               rB4 = pB0[129];
               rC0_1 += rA0 * rB1;
               rB5 = pB0[161];
               rC1_1 += rA1 * rB1;
               rB6 = pB0[193];
               rC2_1 += rA2 * rB1;
               rB7 = pB0[225];
               rC3_1 += rA3 * rB1;
               rC4_1 += rA4 * rB1;
               rC5_1 += rA5 * rB1;
               rC0_2 += rA0 * rB2;
               rC1_2 += rA1 * rB2;
               rC2_2 += rA2 * rB2;
               rC3_2 += rA3 * rB2;
               rC4_2 += rA4 * rB2;
               rC5_2 += rA5 * rB2;
               rC0_3 += rA0 * rB3;
               rC1_3 += rA1 * rB3;
               rC2_3 += rA2 * rB3;
               rC3_3 += rA3 * rB3;
               rC4_3 += rA4 * rB3;
               rC5_3 += rA5 * rB3;
               rC0_4 += rA0 * rB4;
               rC1_4 += rA1 * rB4;
               rC2_4 += rA2 * rB4;
               rC3_4 += rA3 * rB4;
               rC4_4 += rA4 * rB4;
               rC5_4 += rA5 * rB4;
               rC0_5 += rA0 * rB5;
               rC1_5 += rA1 * rB5;
               rC2_5 += rA2 * rB5;
               rC3_5 += rA3 * rB5;
               rC4_5 += rA4 * rB5;
               rC5_5 += rA5 * rB5;
               rC0_6 += rA0 * rB6;
               rC1_6 += rA1 * rB6;
               rC2_6 += rA2 * rB6;
               rC3_6 += rA3 * rB6;
               rC4_6 += rA4 * rB6;
               rC5_6 += rA5 * rB6;
               rC0_7 += rA0 * rB7;
               rC1_7 += rA1 * rB7;
               rC2_7 += rA2 * rB7;
               rC3_7 += rA3 * rB7;
               rC4_7 += rA4 * rB7;
               rC5_7 += rA5 * rB7;
               pA0 += incAk;
               pB0 += incBk;
            }
            *pC0 = rC0_0;
            pC0[2] = rC1_0;
            pC0[4] = rC2_0;
            pC0[6] = rC3_0;
            pC0[8] = rC4_0;
            pC0[10] = rC5_0;
            *pC1 = rC0_1;
            pC1[2] = rC1_1;
            pC1[4] = rC2_1;
            pC1[6] = rC3_1;
            pC1[8] = rC4_1;
            pC1[10] = rC5_1;
            *pC2 = rC0_2;
            pC2[2] = rC1_2;
            pC2[4] = rC2_2;
            pC2[6] = rC3_2;
            pC2[8] = rC4_2;
            pC2[10] = rC5_2;
            *pC3 = rC0_3;
            pC3[2] = rC1_3;
            pC3[4] = rC2_3;
            pC3[6] = rC3_3;
            pC3[8] = rC4_3;
            pC3[10] = rC5_3;
            *pC4 = rC0_4;
            pC4[2] = rC1_4;
            pC4[4] = rC2_4;
            pC4[6] = rC3_4;
            pC4[8] = rC4_4;
            pC4[10] = rC5_4;
            *pC5 = rC0_5;
            pC5[2] = rC1_5;
            pC5[4] = rC2_5;
            pC5[6] = rC3_5;
            pC5[8] = rC4_5;
            pC5[10] = rC5_5;
            *pC6 = rC0_6;
            pC6[2] = rC1_6;
            pC6[4] = rC2_6;
            pC6[6] = rC3_6;
            pC6[8] = rC4_6;
            pC6[10] = rC5_6;
            *pC7 = rC0_7;
            pC7[2] = rC1_7;
            pC7[4] = rC2_7;
            pC7[6] = rC3_7;
            pC7[8] = rC4_7;
            pC7[10] = rC5_7;
            pC0 += incCm;
            pC1 += incCm;
            pC2 += incCm;
            pC3 += incCm;
            pC4 += incCm;
            pC5 += incCm;
            pC6 += incCm;
            pC7 += incCm;
            pA0 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pC1 += incCn;
         pC2 += incCn;
         pC3 += incCn;
         pC4 += incCn;
         pC5 += incCn;
         pC6 += incCn;
         pC7 += incCn;
         pA0 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=N-Nb)
      ATL_cJIK32x0x32TN6x1x2_a1_b0(32, k, 32, alpha, ca, lda, cb + (((Nb) << 5)), ldb, beta, cc + (((Nb*ldc) << 1)), ldc);
   if (Nb)

      ATL_cJIK2x0x32TN2x8x2_a1_b0(2, Nb, 32, alpha, ca + 960, lda, cb, ldb, beta, cc + 60, ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
#ifdef ATL_UCLEANN
#define ATL_cpNBmm_b0 ATL_cgpNBmm_b0
#endif

void ATL_cJIK32x0x32TN32x32x0_a1_b0(const int M, const int N, const int K, const float alpha, const float *A, const int lda, const float *B, const int ldb, const float beta, float *C, const int ldc);
void ATL_cJIK32x0x32TN32x32x0_a1_bX(const int M, const int N, const int K, const float alpha, const float *A, const int lda, const float *B, const int ldb, const float beta, float *C, const int ldc);
void ATL_cJIK32x0x32TN32x32x0_a1_b1(const int M, const int N, const int K, const float alpha, const float *A, const int lda, const float *B, const int ldb, const float beta, float *C, const int ldc);

void ATL_cpNBmm_b0(const int M, const int N, const int K, const float alpha, const float *A, const int lda, const float *B, const int ldb, const float beta, float *C, const int ldc)
{
   ATL_cJIK32x0x32TN32x32x0_a1_b0(M, N, K, alpha, A, lda, B, ldb, -beta, C, ldc);
   ATL_cJIK32x0x32TN32x32x0_a1_b0(M, N, K, alpha, A, lda, B+N*ldb, ldb, beta, C+1, ldc);
   ATL_cJIK32x0x32TN32x32x0_a1_bX(M, N, K, alpha, A+M*lda, lda, B+N*ldb, ldb, -1.0, C, ldc);
   ATL_cJIK32x0x32TN32x32x0_a1_b1(M, N, K, alpha, A+M*lda, lda, B, ldb, 1.0, C+1, ldc);
}
